Attribute VB_Name = "Module1"
Option Explicit
'
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Dest As Any, ByRef Source As Any, ByVal Bytes As Long)
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
'
Public Type POINTAPI
    x As Long
    y As Long
End Type

Public Function TwipsPerPixelX() As Single
    ' In a system with multiple display monitors, this value is the same for all monitors.
    ' It works MUCH better than Screen.TwipsPerPixelX as it recognizes portrait monitors.
    Dim hdc As Long
    Dim lPixelsPerInch As Long
    Const LOGPIXELSX = 88        '  Logical pixels/inch in X
    Const POINTS_PER_INCH As Long = 72 ' A point is defined as 1/72 inches.
    Const TWIPS_PER_POINT As Long = 20 ' Also, by definition.
    '
    hdc = GetDC(0)
    lPixelsPerInch = GetDeviceCaps(hdc, LOGPIXELSX)
    ReleaseDC 0, hdc
    TwipsPerPixelX = TWIPS_PER_POINT * (POINTS_PER_INCH / lPixelsPerInch) ' Cancel units to see it.
End Function

Public Function TwipsPerPixelY() As Single
    ' In a system with multiple display monitors, this value is the same for all monitors.
    ' It works MUCH better than Screen.TwipsPerPixelY as it recognizes portrait monitors.
    Dim hdc As Long
    Dim lPixelsPerInch As Long
    Const LOGPIXELSY = 90        '  Logical pixels/inch in Y
    Const POINTS_PER_INCH As Long = 72 ' A point is defined as 1/72 inches.
    Const TWIPS_PER_POINT As Long = 20 ' Also, by definition.
    '
    hdc = GetDC(0)
    lPixelsPerInch = GetDeviceCaps(hdc, LOGPIXELSY)
    ReleaseDC 0, hdc
    TwipsPerPixelY = TWIPS_PER_POINT * (POINTS_PER_INCH / lPixelsPerInch) ' Cancel units to see it.
End Function


